Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 427)
@@ -43,21 +43,32 @@
 //! \ingroup TLibEncoder
 //! \{
-
+#if LGE_SAO_MIGRATION_D0091
 TEncSampleAdaptiveOffset::TEncSampleAdaptiveOffset()
 {
-  m_pcEntropyCoder = NULL;
-  m_pppcRDSbacCoder = NULL;
-  m_pcRDGoOnSbacCoder = NULL;
-  m_pppcBinCoderCABAC = NULL;            
-  m_iCount = NULL;     
-  m_iOffset = NULL;      
-  m_iOffsetOrg = NULL;  
-  m_iRate = NULL;       
-  m_iDist = NULL;        
-  m_dCost = NULL;        
-  m_dCostPartBest = NULL; 
-  m_iDistOrg = NULL;      
-  m_iTypePartBest = NULL; 
-}
+    m_pcEntropyCoder= NULL;
+    m_pppcRDSbacCoder = NULL;
+    m_pcRDGoOnSbacCoder = NULL;
+    m_pppcBinCoderCABAC = NULL;
+    m_iCount = NULL;
+    m_iOffset = NULL;
+    m_iOffsetOrg = NULL;
+    m_iRate = NULL;
+    m_iDist = NULL;
+    m_dCost = NULL;
+    m_dCostPartBest = NULL;
+    m_iDistOrg = NULL;
+    m_iTypePartBest = NULL;
+#if SAO_ENCODING_CHOICE_CHROMA
+    m_depthSaoRate[0][0] = 0;
+    m_depthSaoRate[0][1] = 0;
+    m_depthSaoRate[0][2] = 0;
+    m_depthSaoRate[0][3] = 0;
+    m_depthSaoRate[1][0] = 0;
+    m_depthSaoRate[1][1] = 0;
+    m_depthSaoRate[1][2] = 0;
+    m_depthSaoRate[1][3] = 0;
+#endif
+}
+
 TEncSampleAdaptiveOffset::~TEncSampleAdaptiveOffset()
 {
@@ -76,8 +87,8 @@
 {
 #if FULL_NBIT
-  Int bitDepthMinus8 = g_uiBitDepth - 8;
-  return ((x)>0) ? (Int)(((Int)(x)+(1<<(bitDepthMinus8-1)))/(1<<bitDepthMinus8)) : ((Int)(((Int)(x)-(1<<(bitDepthMinus8-1)))/(1<<bitDepthMinus8)));
+    Int bitDepthMinus8 = g_uiBitDepth - 8;
+    return ((x)>0) ? (Int)(((Int)(x)+(1<<(bitDepthMinus8-1)))/(1<<bitDepthMinus8)) : ((Int)(((Int)(x)-(1<<(bitDepthMinus8-1)))/(1<<bitDepthMinus8)));
 #else
-  return ((x)>0) ? (Int)(((Int)(x)+(1<<(g_uiBitIncrement-1)))/(1<<g_uiBitIncrement)) : ((Int)(((Int)(x)-(1<<(g_uiBitIncrement-1)))/(1<<g_uiBitIncrement)));
+    return ((x)>0) ? (Int)(((Int)(x)+(1<<(g_uiBitIncrement-1)))/(1<<g_uiBitIncrement)) : ((Int)(((Int)(x)-(1<<(g_uiBitIncrement-1)))/(1<<g_uiBitIncrement)));
 #endif
 }
@@ -89,252 +100,241 @@
 {
 #if FULL_NBIT
-  return (g_uiBitDepth > 8 ? xRoundIbdi2((x)) : ((x)>=0 ? ((Int)((x)+0.5)) : ((Int)((x)-0.5)))) ;
+    return (g_uiBitDepth > 8 ? xRoundIbdi2((x)) : ((x)>=0 ? ((Int)((x)+0.5)) : ((Int)((x)-0.5)))) ;
 #else
-  return (g_uiBitIncrement >0 ? xRoundIbdi2((x)) : ((x)>=0 ? ((Int)((x)+0.5)) : ((Int)((x)-0.5)))) ;
-#endif
-}
-
-
+    return (g_uiBitIncrement >0 ? xRoundIbdi2((x)) : ((x)>=0 ? ((Int)((x)+0.5)) : ((Int)((x)-0.5)))) ;
+#endif
+}
 
 /** process SAO for one partition
  * \param  *psQTPart, iPartIdx, dLambda
  */
-Void TEncSampleAdaptiveOffset::rdoSaoOnePart(SAOQTPart *psQTPart, Int iPartIdx, Double dLambda)
-{
-  Int iTypeIdx;
-  Int iNumTotalType = MAX_NUM_SAO_TYPE;
-  SAOQTPart*  pOnePart = &(psQTPart[iPartIdx]);
-
-  Int64 iEstDist;
-  Int64 iOffsetOrg;
-  Int64 iOffset;
-  Int64 iCount;
-  Int iClassIdx;
-  Int uiShift = g_uiBitIncrement << 1;
-  UInt uiDepth = pOnePart->PartLevel;
-
-  m_iDistOrg [iPartIdx] =  0;
-
-  Double  bestRDCostTableBo = MAX_DOUBLE;
-  Int     bestClassTableBo    = 0;
-  Int     currentDistortionTableBo[MAX_NUM_SAO_CLASS];
-  Double  currentRdCostTableBo[MAX_NUM_SAO_CLASS];
-
-#if HHI_INTERVIEW_SKIP
-  Int iFrameWidthInCU = m_pcPic->getFrameWidthInCU();
-  Int LcuIdxX = psQTPart->StartCUX;
-  Int LcuIdxY = psQTPart->StartCUY;
-  Int iAddr = LcuIdxY*iFrameWidthInCU + LcuIdxX;
-  TComDataCU *pcCU = m_pcPic->getCU(iAddr);
-  Bool bRenderable = pcCU->getRenderable(0) ;
-
-#endif
-  for (iTypeIdx=-1; iTypeIdx<iNumTotalType; iTypeIdx++)
-  {
-    if( m_bUseSBACRD )
-    {
-      m_pcRDGoOnSbacCoder->load(m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST]);
-      m_pcRDGoOnSbacCoder->resetBits();
+Void TEncSampleAdaptiveOffset::rdoSaoOnePart(SAOQTPart *psQTPart, Int iPartIdx, Double dLambda, Int yCbCr)
+{
+    Int iTypeIdx;
+    Int iNumTotalType = MAX_NUM_SAO_TYPE;
+    SAOQTPart*  pOnePart = &(psQTPart[iPartIdx]);
+
+    Int64 iEstDist;
+    Int iClassIdx;
+    Int uiShift = g_uiBitIncrement << 1;
+    UInt uiDepth = pOnePart->PartLevel;
+
+    m_iDistOrg [iPartIdx] =  0;
+
+    Double  bestRDCostTableBo = MAX_DOUBLE;
+    Int     bestClassTableBo    = 0;
+    Int     currentDistortionTableBo[MAX_NUM_SAO_CLASS];
+    Double  currentRdCostTableBo[MAX_NUM_SAO_CLASS];
+
+    Int addr;
+    Int allowMergeLeft;
+    Int allowMergeUp;
+    Int frameWidthInCU = m_pcPic->getFrameWidthInCU();
+    SaoLcuParam  saoLcuParamRdo;
+
+    for (iTypeIdx=-1; iTypeIdx<iNumTotalType; iTypeIdx++)
+    {
+        if( m_bUseSBACRD )
+        {
+            m_pcRDGoOnSbacCoder->load(m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST]);
+            m_pcRDGoOnSbacCoder->resetBits();
+        }
+        else
+        {
+            m_pcEntropyCoder->resetEntropy();
+            m_pcEntropyCoder->resetBits();
+        }
+
+        iEstDist = 0;
+
+        if (iTypeIdx == -1)
+        {      
+            for (Int ry = pOnePart->StartCUY; ry<= pOnePart->EndCUY; ry++)
+            {
+                for (Int rx = pOnePart->StartCUX; rx <= pOnePart->EndCUX; rx++)
+                {
+                    addr = ry * frameWidthInCU + rx;
+                    // get bits for iTypeIdx = -1
+                    allowMergeLeft = 1;
+                    allowMergeUp   = 1;
+                    if (rx != 0)
+                    { 
+                        // check tile id and slice id 
+                        if ( (m_pcPic->getPicSym()->getTileIdxMap(addr-1) != m_pcPic->getPicSym()->getTileIdxMap(addr)) || (m_pcPic->getCU(addr-1)->getSlice()->getSliceIdx() != m_pcPic->getCU(addr)->getSlice()->getSliceIdx()))
+                        {
+                            allowMergeLeft = 0;
+                        }
+                    }
+                    if (ry!=0)
+                    {
+                        if ( (m_pcPic->getPicSym()->getTileIdxMap(addr-m_iNumCuInWidth) != m_pcPic->getPicSym()->getTileIdxMap(addr)) || (m_pcPic->getCU(addr-m_iNumCuInWidth)->getSlice()->getSliceIdx() != m_pcPic->getCU(addr)->getSlice()->getSliceIdx()))
+                        {
+                            allowMergeUp = 0;
+                        }
+                    }
+
+                    // reset
+                    resetSaoUnit(&saoLcuParamRdo);
+        
+                    // set merge flag
+                    saoLcuParamRdo.mergeUpFlag   = 1;
+                    saoLcuParamRdo.mergeLeftFlag = 1;
+        
+                    if (ry == pOnePart->StartCUY) 
+                    {
+                        saoLcuParamRdo.mergeUpFlag = 0;
+                    } 
+
+                    if (rx == pOnePart->StartCUX) 
+                    {
+                        saoLcuParamRdo.mergeLeftFlag = 0;
+                    }
+
+                    m_pcEntropyCoder->encodeSaoUnitInterleaving(yCbCr, 1, rx, ry,  &saoLcuParamRdo, 1,  1,  allowMergeLeft, allowMergeUp);
+
+                }
+            }
+        }
+
+        if (iTypeIdx>=0)
+        {
+            iEstDist = estSaoTypeDist(iPartIdx, iTypeIdx, uiShift, dLambda, currentDistortionTableBo, currentRdCostTableBo);
+            if( iTypeIdx == SAO_BO )
+            {
+                // Estimate Best Position
+                Double currentRDCost = 0.0;
+    
+                for(Int i=0; i< SAO_MAX_BO_CLASSES -SAO_BO_LEN +1; i++)
+                {
+                    currentRDCost = 0.0;
+                    for(UInt uj = i; uj < i+SAO_BO_LEN; uj++)
+                    {
+                        currentRDCost += currentRdCostTableBo[uj];
+                    }
+
+                    if( currentRDCost < bestRDCostTableBo)
+                    {
+                        bestRDCostTableBo = currentRDCost;
+                        bestClassTableBo  = i;
+                    }
+                }
+
+                // Re code all Offsets
+                // Code Center
+                for(iClassIdx = bestClassTableBo; iClassIdx < bestClassTableBo+SAO_BO_LEN; iClassIdx++)
+                {
+                    iEstDist += currentDistortionTableBo[iClassIdx];
+                }
+            }
+
+            for (Int ry = pOnePart->StartCUY; ry<= pOnePart->EndCUY; ry++)
+            {
+                for (Int rx = pOnePart->StartCUX; rx <= pOnePart->EndCUX; rx++)
+                {
+                    addr = ry * frameWidthInCU + rx;          
+        
+                    // get bits for iTypeIdx = -1
+                    allowMergeLeft = 1;
+                    allowMergeUp   = 1;
+                    if (rx != 0)
+                    { 
+                        // check tile id and slice id 
+                        if ( (m_pcPic->getPicSym()->getTileIdxMap(addr-1) != m_pcPic->getPicSym()->getTileIdxMap(addr)) || (m_pcPic->getCU(addr-1)->getSlice()->getSliceIdx() != m_pcPic->getCU(addr)->getSlice()->getSliceIdx()))
+                        {
+                            allowMergeLeft = 0;
+                        }
+                    }
+                    if (ry!=0)
+                    {
+                        if ( (m_pcPic->getPicSym()->getTileIdxMap(addr-m_iNumCuInWidth) != m_pcPic->getPicSym()->getTileIdxMap(addr)) || (m_pcPic->getCU(addr-m_iNumCuInWidth)->getSlice()->getSliceIdx() != m_pcPic->getCU(addr)->getSlice()->getSliceIdx()))
+                        {
+                            allowMergeUp = 0;
+                        }
+                    }
+    
+                    // reset
+                    resetSaoUnit(&saoLcuParamRdo);
+
+                    // set merge flag
+                    saoLcuParamRdo.mergeUpFlag   = 1;
+                    saoLcuParamRdo.mergeLeftFlag = 1;
+    
+                    if (ry == pOnePart->StartCUY) 
+                    {
+                        saoLcuParamRdo.mergeUpFlag = 0;
+                    } 
+    
+                    if (rx == pOnePart->StartCUX) 
+                    {
+                        saoLcuParamRdo.mergeLeftFlag = 0;
+                    }
+
+                    // set type and offsets
+                    saoLcuParamRdo.typeIdx = iTypeIdx;
+                    saoLcuParamRdo.subTypeIdx = (iTypeIdx==SAO_BO)?bestClassTableBo:0;
+                    saoLcuParamRdo.length = m_iNumClass[iTypeIdx];
+                    for (iClassIdx = 0; iClassIdx < saoLcuParamRdo.length; iClassIdx++)
+                    {
+                        saoLcuParamRdo.offset[iClassIdx] = (Int)m_iOffset[iPartIdx][iTypeIdx][iClassIdx+saoLcuParamRdo.subTypeIdx+1];
+                    }
+
+                    m_pcEntropyCoder->encodeSaoUnitInterleaving(yCbCr, 1, rx, ry,  &saoLcuParamRdo, 1,  1,  allowMergeLeft, allowMergeUp);
+
+                }
+            }
+
+            m_iDist[iPartIdx][iTypeIdx] = iEstDist;
+            m_iRate[iPartIdx][iTypeIdx] = m_pcEntropyCoder->getNumberOfWrittenBits();
+
+            m_dCost[iPartIdx][iTypeIdx] = (Double)((Double)m_iDist[iPartIdx][iTypeIdx] + dLambda * (Double) m_iRate[iPartIdx][iTypeIdx]);
+
+            if(m_dCost[iPartIdx][iTypeIdx] < m_dCostPartBest[iPartIdx])
+            {
+                m_iDistOrg [iPartIdx] = 0;
+                m_dCostPartBest[iPartIdx] = m_dCost[iPartIdx][iTypeIdx];
+                m_iTypePartBest[iPartIdx] = iTypeIdx;
+                if( m_bUseSBACRD )
+                    m_pcRDGoOnSbacCoder->store( m_pppcRDSbacCoder[pOnePart->PartLevel][CI_TEMP_BEST] );
+            }
+        }
+        else
+        {
+            if(m_iDistOrg[iPartIdx] < m_dCostPartBest[iPartIdx] )
+            {
+                m_dCostPartBest[iPartIdx] = (Double) m_iDistOrg[iPartIdx] + m_pcEntropyCoder->getNumberOfWrittenBits()*dLambda ; 
+                m_iTypePartBest[iPartIdx] = -1;
+                if( m_bUseSBACRD )
+                    m_pcRDGoOnSbacCoder->store( m_pppcRDSbacCoder[pOnePart->PartLevel][CI_TEMP_BEST] );
+            }
+        }
+    }
+
+    pOnePart->bProcessed = true;
+    pOnePart->bSplit     = false;
+    pOnePart->iMinDist   =        m_iTypePartBest[iPartIdx] >= 0 ? m_iDist[iPartIdx][m_iTypePartBest[iPartIdx]] : m_iDistOrg[iPartIdx];
+    pOnePart->iMinRate   = (Int) (m_iTypePartBest[iPartIdx] >= 0 ? m_iRate[iPartIdx][m_iTypePartBest[iPartIdx]] : 0);
+    pOnePart->dMinCost   = pOnePart->iMinDist + dLambda * pOnePart->iMinRate;
+    pOnePart->iBestType  = m_iTypePartBest[iPartIdx];
+    if (pOnePart->iBestType != -1)
+    {
+        //     pOnePart->bEnableFlag =  1;
+        pOnePart->iLength = m_iNumClass[pOnePart->iBestType];
+        Int minIndex = 0;
+        if( pOnePart->iBestType == SAO_BO )
+        {
+            pOnePart->subTypeIdx = bestClassTableBo;
+            minIndex = pOnePart->subTypeIdx;
+        }
+        for (Int i=0; i< pOnePart->iLength ; i++)
+        {
+            pOnePart->iOffset[i] = (Int) m_iOffset[iPartIdx][pOnePart->iBestType][minIndex+i+1];
+        }
+
     }
     else
     {
-      m_pcEntropyCoder->resetEntropy();
-      m_pcEntropyCoder->resetBits();
-    }
-
-    iEstDist = 0;
-
-    m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoTypeIdx(iTypeIdx+1);
-
-    if (iTypeIdx>=0)
-    {
-
-      for(iClassIdx=1; iClassIdx < ( (iTypeIdx < SAO_BO) ?  m_iNumClass[iTypeIdx]+1 : SAO_MAX_BO_CLASSES+1); iClassIdx++)
-      {
-        if( iTypeIdx == SAO_BO)
-        {
-          currentDistortionTableBo[iClassIdx-1] = 0;
-          currentRdCostTableBo[iClassIdx-1] = dLambda;
-        }
-#if HHI_INTERVIEW_SKIP
-        if(m_iCount [iPartIdx][iTypeIdx][iClassIdx] && !bRenderable)
-#else
-        if(m_iCount [iPartIdx][iTypeIdx][iClassIdx])
-#endif
-        {
-#if FULL_NBIT
-          m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = (Int64) xRoundIbdi((Double)(m_iOffsetOrg[iPartIdx][iTypeIdx][iClassIdx]<<g_uiBitDepth-8) / (Double)(m_iCount [iPartIdx][iTypeIdx][iClassIdx]<<m_uiSaoBitIncrease));
-#else
-          m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = (Int64) xRoundIbdi((Double)(m_iOffsetOrg[iPartIdx][iTypeIdx][iClassIdx]<<g_uiBitIncrement) / (Double)(m_iCount [iPartIdx][iTypeIdx][iClassIdx]<<m_uiSaoBitIncrease));
-#endif
-          m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = Clip3(-m_iOffsetTh, m_iOffsetTh-1, (Int)m_iOffset[iPartIdx][iTypeIdx][iClassIdx]);
-
-          if (iTypeIdx < 4)
-          {
-            if ( m_iOffset[iPartIdx][iTypeIdx][iClassIdx]<0 && iClassIdx<3 )
-            {
-              m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = 0;
-            }
-            if ( m_iOffset[iPartIdx][iTypeIdx][iClassIdx]>0 && iClassIdx>=3)
-            {
-              m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = 0;
-            }
-          }
-          {
-            //Clean up, best_q_offset.
-            Int64 iIterOffset, iTempOffset;
-            Int64 iTempDist, iTempRate;
-            Double dTempCost, dTempMinCost;
-            UInt uiLength, uiTemp;
-
-            iIterOffset = m_iOffset[iPartIdx][iTypeIdx][iClassIdx];
-            m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = 0;
-            dTempMinCost = dLambda; // Assuming sending quantized value 0 results in zero offset and sending the value zero needs 1 bit. entropy coder can be used to measure the exact rate here. 
-
-            while (iIterOffset != 0)
-            {
-              // Calculate the bits required for signalling the offset
-              uiLength = 1;
-              uiTemp = (UInt)((iIterOffset <= 0) ? ( (-iIterOffset<<1) + 1 ) : (iIterOffset<<1));
-              while( 1 != uiTemp )
-              {
-                uiTemp >>= 1;
-                uiLength += 2;
-              }
-              iTempRate = (uiLength >> 1) + ((uiLength+1) >> 1);
-
-              // Do the dequntization before distorion calculation
-              iTempOffset    =  iIterOffset << m_uiSaoBitIncrease;
-              iTempDist  = (( m_iCount [iPartIdx][iTypeIdx][iClassIdx]*iTempOffset*iTempOffset-m_iOffsetOrg[iPartIdx][iTypeIdx][iClassIdx]*iTempOffset*2 ) >> uiShift);
-
-              dTempCost = ((Double)iTempDist + dLambda * (Double) iTempRate);
-              if(dTempCost < dTempMinCost)
-              {
-                dTempMinCost = dTempCost;
-                m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = iIterOffset;
-                if(iTypeIdx == SAO_BO)
-                {
-                  currentDistortionTableBo[iClassIdx-1] = (Int) iTempDist;
-                  currentRdCostTableBo[iClassIdx-1] = dTempCost;
-                }
-              }
-              iIterOffset = (iIterOffset > 0) ? (iIterOffset-1):(iIterOffset+1);
-            }
-
-          }
-        }
-        else
-        {
-          m_iOffsetOrg[iPartIdx][iTypeIdx][iClassIdx] = 0;
-          m_iOffset[iPartIdx][iTypeIdx][iClassIdx] = 0;
-        }
-        if( iTypeIdx != SAO_BO )
-        {
-          iCount     =  m_iCount [iPartIdx][iTypeIdx][iClassIdx];
-          iOffset    =  m_iOffset[iPartIdx][iTypeIdx][iClassIdx] << m_uiSaoBitIncrease;
-          iOffsetOrg =  m_iOffsetOrg[iPartIdx][iTypeIdx][iClassIdx];
-          iEstDist   += (( iCount*iOffset*iOffset-iOffsetOrg*iOffset*2 ) >> uiShift);
-          if (iTypeIdx < 4)
-          {
-            if (iClassIdx<3)
-            {
-              m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoUvlc((Int)m_iOffset[iPartIdx][iTypeIdx][iClassIdx]);
-            }
-            else
-            {
-              m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoUvlc((Int)-m_iOffset[iPartIdx][iTypeIdx][iClassIdx]);
-            }
-          }
-          else
-          {
-            m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoSvlc((Int)m_iOffset[iPartIdx][iTypeIdx][iClassIdx]);
-          }
-        }
-      }
-
-      if( iTypeIdx == SAO_BO )
-      {
-        // Estimate Best Position
-        Double currentRDCost = 0.0;
-
-        for(Int i=0; i< SAO_MAX_BO_CLASSES -SAO_BO_LEN +1; i++)
-        {
-          currentRDCost = 0.0;
-          for(UInt uj = i; uj < i+SAO_BO_LEN; uj++)
-          {
-            currentRDCost += currentRdCostTableBo[uj];
-          }
-
-          if( currentRDCost < bestRDCostTableBo)
-          {
-            bestRDCostTableBo = currentRDCost;
-            bestClassTableBo  = i;
-          }
-        }
-
-        // Re code all Offsets
-        // Code Center
-        m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoUflc( (UInt) (bestClassTableBo) );
-
-        for(iClassIdx = bestClassTableBo; iClassIdx < bestClassTableBo+SAO_BO_LEN; iClassIdx++)
-        {
-          m_pcEntropyCoder->m_pcEntropyCoderIf->codeSaoSvlc((Int)m_iOffset[iPartIdx][iTypeIdx][iClassIdx+1]);
-          iEstDist += currentDistortionTableBo[iClassIdx];
-        }
-      }
-
-      m_iDist[iPartIdx][iTypeIdx] = iEstDist;
-      m_iRate[iPartIdx][iTypeIdx] = m_pcEntropyCoder->getNumberOfWrittenBits();
-
-      m_dCost[iPartIdx][iTypeIdx] = (Double)((Double)m_iDist[iPartIdx][iTypeIdx] + dLambda * (Double) m_iRate[iPartIdx][iTypeIdx]);
-
-      if(m_dCost[iPartIdx][iTypeIdx] < m_dCostPartBest[iPartIdx])
-      {
-        m_iDistOrg [iPartIdx] = 0;
-        m_dCostPartBest[iPartIdx] = m_dCost[iPartIdx][iTypeIdx];
-        m_iTypePartBest[iPartIdx] = iTypeIdx;
-        if( m_bUseSBACRD )
-          m_pcRDGoOnSbacCoder->store( m_pppcRDSbacCoder[pOnePart->PartLevel][CI_TEMP_BEST] );
-      }
-    }
-    else
-    {
-      if(m_iDistOrg[iPartIdx] < m_dCostPartBest[iPartIdx] )
-      {
-        m_dCostPartBest[iPartIdx] = (Double) m_iDistOrg[iPartIdx] + m_pcEntropyCoder->getNumberOfWrittenBits()*dLambda ; 
-        m_iTypePartBest[iPartIdx] = -1;
-        if( m_bUseSBACRD )
-          m_pcRDGoOnSbacCoder->store( m_pppcRDSbacCoder[pOnePart->PartLevel][CI_TEMP_BEST] );
-      }
-    }
-  }
-
-  pOnePart->bProcessed = true;
-  pOnePart->bSplit     = false;
-  pOnePart->iMinDist   =        m_iTypePartBest[iPartIdx] >= 0 ? m_iDist[iPartIdx][m_iTypePartBest[iPartIdx]] : m_iDistOrg[iPartIdx];
-  pOnePart->iMinRate   = (Int) (m_iTypePartBest[iPartIdx] >= 0 ? m_iRate[iPartIdx][m_iTypePartBest[iPartIdx]] : 0);
-  pOnePart->dMinCost   = pOnePart->iMinDist + dLambda * pOnePart->iMinRate;
-  pOnePart->iBestType  = m_iTypePartBest[iPartIdx];
-  if (pOnePart->iBestType != -1)
-  {
-    //     pOnePart->bEnableFlag =  1;
-    pOnePart->iLength = m_iNumClass[pOnePart->iBestType];
-    Int minIndex = 0;
-    if( pOnePart->iBestType == SAO_BO )
-    {
-      pOnePart->bandPosition = bestClassTableBo;
-      minIndex = pOnePart->bandPosition;
-    }
-    for (Int i=0; i< pOnePart->iLength ; i++)
-    {
-      pOnePart->iOffset[i] = (Int) m_iOffset[iPartIdx][pOnePart->iBestType][minIndex+i+1];
-    }
-
-  }
-  else
-  {
-    //     pOnePart->bEnableFlag = 0;
-    pOnePart->iLength     = 0;
-  }
+        //     pOnePart->bEnableFlag = 0;
+        pOnePart->iLength     = 0;
+    }
 }
 
@@ -343,16 +343,16 @@
 Void TEncSampleAdaptiveOffset::disablePartTree(SAOQTPart *psQTPart, Int iPartIdx)
 {
-  SAOQTPart*  pOnePart= &(psQTPart[iPartIdx]);
-  pOnePart->bSplit      = false;
-  pOnePart->iLength     =  0;
-  pOnePart->iBestType   = -1;
-
-  if (pOnePart->PartLevel < m_uiMaxSplitLevel)
-  {
-    for (Int i=0; i<NUM_DOWN_PART; i++)
-    {
-      disablePartTree(psQTPart, pOnePart->DownPartsIdx[i]);
-    }
-  }
+    SAOQTPart*  pOnePart= &(psQTPart[iPartIdx]);
+    pOnePart->bSplit      = false;
+    pOnePart->iLength     =  0;
+    pOnePart->iBestType   = -1;
+
+    if (pOnePart->PartLevel < m_uiMaxSplitLevel)
+    {
+        for (Int i=0; i<NUM_DOWN_PART; i++)
+        {
+            disablePartTree(psQTPart, pOnePart->DownPartsIdx[i]);
+        }
+    }
 }
 
@@ -360,78 +360,78 @@
  * \param  iPartIdx, pcPicOrg, pcPicDec, pcPicRest, &dCostFinal
  */
-Void TEncSampleAdaptiveOffset::runQuadTreeDecision(SAOQTPart *psQTPart, Int iPartIdx, Double &dCostFinal, Int iMaxLevel, Double dLambda)
-{
-  SAOQTPart*  pOnePart = &(psQTPart[iPartIdx]);
-
-  UInt uiDepth = pOnePart->PartLevel;
-  UInt uhNextDepth = uiDepth+1;
-
-  if (iPartIdx == 0)
-  {
-    dCostFinal = 0;
-  }
-
-  //SAO for this part
-  if(!pOnePart->bProcessed)
-  {
-    rdoSaoOnePart (psQTPart, iPartIdx, dLambda);
-  }
-
-  //SAO for sub 4 parts
-  if (pOnePart->PartLevel < iMaxLevel)
-  {
-    Double      dCostNotSplit = dLambda + pOnePart->dMinCost;
-    Double      dCostSplit    = dLambda;
-
-    for (Int i=0; i< NUM_DOWN_PART ;i++)
-    {
-      if( m_bUseSBACRD )  
-      {
-        if ( 0 == i) //initialize RD with previous depth buffer
-        {
-          m_pppcRDSbacCoder[uhNextDepth][CI_CURR_BEST]->load(m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST]);
+Void TEncSampleAdaptiveOffset::runQuadTreeDecision(SAOQTPart *psQTPart, Int iPartIdx, Double &dCostFinal, Int iMaxLevel, Double dLambda, Int yCbCr)
+{
+    SAOQTPart*  pOnePart = &(psQTPart[iPartIdx]);
+
+    UInt uiDepth = pOnePart->PartLevel;
+    UInt uhNextDepth = uiDepth+1;
+
+    if (iPartIdx == 0)
+    {
+        dCostFinal = 0;
+    }
+
+    //SAO for this part
+    if(!pOnePart->bProcessed)
+    {
+        rdoSaoOnePart (psQTPart, iPartIdx, dLambda, yCbCr);
+    }
+
+    //SAO for sub 4 parts
+    if (pOnePart->PartLevel < iMaxLevel)
+    {
+        Double      dCostNotSplit = dLambda + pOnePart->dMinCost;
+        Double      dCostSplit    = dLambda;
+
+        for (Int i=0; i< NUM_DOWN_PART ;i++)
+        {
+            if( m_bUseSBACRD )
+            {
+                if ( 0 == i) //initialize RD with previous depth buffer
+                {
+                    m_pppcRDSbacCoder[uhNextDepth][CI_CURR_BEST]->load(m_pppcRDSbacCoder[uiDepth][CI_CURR_BEST]);
+                }
+                else
+                {
+                    m_pppcRDSbacCoder[uhNextDepth][CI_CURR_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]);
+                }
+            }
+            runQuadTreeDecision(psQTPart, pOnePart->DownPartsIdx[i], dCostFinal, iMaxLevel, dLambda, yCbCr);
+            dCostSplit += dCostFinal;
+            if( m_bUseSBACRD )
+            {
+                m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_TEMP_BEST]);
+            }
+        }
+
+        if(dCostSplit < dCostNotSplit)
+        {
+            dCostFinal = dCostSplit;
+            pOnePart->bSplit      = true;
+            pOnePart->iLength     =  0;
+            pOnePart->iBestType   = -1;
+            if( m_bUseSBACRD )
+            {
+                m_pppcRDSbacCoder[uiDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]);
+            }
         }
         else
         {
-          m_pppcRDSbacCoder[uhNextDepth][CI_CURR_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]);
-        }
-      }  
-      runQuadTreeDecision(psQTPart, pOnePart->DownPartsIdx[i], dCostFinal, iMaxLevel, dLambda);
-      dCostSplit += dCostFinal;
-      if( m_bUseSBACRD )
-      {
-        m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_TEMP_BEST]);
-      }
-    }
-
-    if(dCostSplit < dCostNotSplit)
-    {
-      dCostFinal = dCostSplit;
-      pOnePart->bSplit      = true;
-      pOnePart->iLength     =  0;
-      pOnePart->iBestType   = -1;
-      if( m_bUseSBACRD )
-      {
-        m_pppcRDSbacCoder[uiDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uhNextDepth][CI_NEXT_BEST]);
-      }
+            dCostFinal = dCostNotSplit;
+            pOnePart->bSplit = false;
+            for (Int i=0; i<NUM_DOWN_PART; i++)
+            {
+                disablePartTree(psQTPart, pOnePart->DownPartsIdx[i]);
+            }
+            if( m_bUseSBACRD )
+            {
+                m_pppcRDSbacCoder[uiDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uiDepth][CI_TEMP_BEST]);
+            }
+        }
     }
     else
     {
-      dCostFinal = dCostNotSplit;
-      pOnePart->bSplit = false;
-      for (Int i=0; i<NUM_DOWN_PART; i++)
-      {
-        disablePartTree(psQTPart, pOnePart->DownPartsIdx[i]);
-      }
-      if( m_bUseSBACRD )
-      {
-        m_pppcRDSbacCoder[uiDepth][CI_NEXT_BEST]->load(m_pppcRDSbacCoder[uiDepth][CI_TEMP_BEST]);
-      }
-    }
-  }
-  else
-  {
-    dCostFinal = pOnePart->dMinCost;
-  }
+        dCostFinal = pOnePart->dMinCost;
+    }
 }
 
@@ -446,5 +446,5 @@
       if (m_iCount [i][j])
       {
-        delete [] m_iCount [i][j]; 
+        delete [] m_iCount [i][j];
       }
       if (m_iOffset[i][j])
@@ -454,5 +454,5 @@
       if (m_iOffsetOrg[i][j])
       {
-        delete [] m_iOffsetOrg[i][j]; 
+        delete [] m_iOffsetOrg[i][j];
       }
     }
@@ -463,5 +463,5 @@
     if (m_iDist[i])
     {
-      delete [] m_iDist[i]; 
+      delete [] m_iDist[i];
     }
     if (m_dCost[i])
@@ -471,5 +471,5 @@
     if (m_iCount [i])
     {
-      delete [] m_iCount [i]; 
+      delete [] m_iCount [i];
     }
     if (m_iOffset[i])
@@ -479,7 +479,6 @@
     if (m_iOffsetOrg[i])
     {
-      delete [] m_iOffsetOrg[i]; 
-    }
-
+      delete [] m_iOffsetOrg[i];
+    }
   }
   if (m_iDistOrg)
@@ -518,4 +517,47 @@
   {
     delete [] m_iOffsetOrg ; m_iOffsetOrg = NULL;
+  }
+  Int numLcu = m_iNumCuInWidth * m_iNumCuInHeight;
+
+  for (Int i=0;i<numLcu;i++)
+  {
+    for (Int j=0;j<3;j++)
+    {
+      for (Int k=0;k<MAX_NUM_SAO_TYPE;k++)
+      {
+        if (m_count_PreDblk [i][j][k])
+        {
+          delete [] m_count_PreDblk [i][j][k];
+        }
+        if (m_offsetOrg_PreDblk[i][j][k])
+        {
+          delete [] m_offsetOrg_PreDblk[i][j][k];
+        }
+      }
+      if (m_count_PreDblk [i][j])
+      {
+        delete [] m_count_PreDblk [i][j];
+      }
+      if (m_offsetOrg_PreDblk[i][j])
+      {
+        delete [] m_offsetOrg_PreDblk[i][j];
+      }
+    }
+    if (m_count_PreDblk [i])
+    {
+      delete [] m_count_PreDblk [i];
+    }
+    if (m_offsetOrg_PreDblk[i])
+    {
+      delete [] m_offsetOrg_PreDblk[i];
+    }
+  }
+  if (m_count_PreDblk)
+  {
+    delete [] m_count_PreDblk  ; m_count_PreDblk = NULL;
+  }
+  if (m_offsetOrg_PreDblk)
+  {
+    delete [] m_offsetOrg_PreDblk ; m_offsetOrg_PreDblk = NULL;
   }
 
@@ -546,7 +588,7 @@
 Void TEncSampleAdaptiveOffset::createEncBuffer()
 {
-  m_iDistOrg = new Int64 [m_iNumTotalParts]; 
-  m_dCostPartBest = new Double [m_iNumTotalParts]; 
-  m_iTypePartBest = new Int [m_iNumTotalParts]; 
+  m_iDistOrg = new Int64 [m_iNumTotalParts];
+  m_dCostPartBest = new Double [m_iNumTotalParts];
+  m_iTypePartBest = new Int [m_iNumTotalParts];
 
   m_iRate = new Int64* [m_iNumTotalParts];
@@ -561,16 +603,36 @@
   {
     m_iRate[i] = new Int64  [MAX_NUM_SAO_TYPE];
-    m_iDist[i] = new Int64  [MAX_NUM_SAO_TYPE]; 
-    m_dCost[i] = new Double [MAX_NUM_SAO_TYPE]; 
-
-    m_iCount [i] = new Int64 *[MAX_NUM_SAO_TYPE]; 
-    m_iOffset[i] = new Int64 *[MAX_NUM_SAO_TYPE]; 
-    m_iOffsetOrg[i] = new Int64 *[MAX_NUM_SAO_TYPE]; 
+    m_iDist[i] = new Int64  [MAX_NUM_SAO_TYPE];
+    m_dCost[i] = new Double [MAX_NUM_SAO_TYPE];
+
+    m_iCount [i] = new Int64 *[MAX_NUM_SAO_TYPE];
+    m_iOffset[i] = new Int64 *[MAX_NUM_SAO_TYPE];
+    m_iOffsetOrg[i] = new Int64 *[MAX_NUM_SAO_TYPE];
 
     for (Int j=0;j<MAX_NUM_SAO_TYPE;j++)
     {
-      m_iCount [i][j]   = new Int64 [MAX_NUM_SAO_CLASS]; 
-      m_iOffset[i][j]   = new Int64 [MAX_NUM_SAO_CLASS]; 
-      m_iOffsetOrg[i][j]= new Int64 [MAX_NUM_SAO_CLASS]; 
+      m_iCount [i][j]   = new Int64 [MAX_NUM_SAO_CLASS];
+      m_iOffset[i][j]   = new Int64 [MAX_NUM_SAO_CLASS];
+      m_iOffsetOrg[i][j]= new Int64 [MAX_NUM_SAO_CLASS];
+    }
+  }
+  Int numLcu = m_iNumCuInWidth * m_iNumCuInHeight;
+  m_count_PreDblk  = new Int64 ***[numLcu];
+  m_offsetOrg_PreDblk = new Int64 ***[numLcu];
+  for (Int i=0; i<numLcu; i++)
+  {
+    m_count_PreDblk[i]  = new Int64 **[3];
+    m_offsetOrg_PreDblk[i] = new Int64 **[3];
+
+    for (Int j=0;j<3;j++)
+    {
+      m_count_PreDblk [i][j] = new Int64 *[MAX_NUM_SAO_TYPE];
+      m_offsetOrg_PreDblk[i][j] = new Int64 *[MAX_NUM_SAO_TYPE];
+
+      for (Int k=0;k<MAX_NUM_SAO_TYPE;k++)
+      {
+        m_count_PreDblk [i][j][k]   = new Int64 [MAX_NUM_SAO_CLASS];
+        m_offsetOrg_PreDblk[i][j][k]= new Int64 [MAX_NUM_SAO_CLASS];
+      }
     }
   }
@@ -606,17 +668,14 @@
 
 /** Start SAO encoder
- * \param pcPic, pcEntropyCoder, pppcRDSbacCoder, pcRDGoOnSbacCoder 
+ * \param pcPic, pcEntropyCoder, pppcRDSbacCoder, pcRDGoOnSbacCoder
  */
 Void TEncSampleAdaptiveOffset::startSaoEnc( TComPic* pcPic, TEncEntropy* pcEntropyCoder, TEncSbac*** pppcRDSbacCoder, TEncSbac* pcRDGoOnSbacCoder)
 {
-  if( pcRDGoOnSbacCoder )
-    m_bUseSBACRD = true;
-  else
-    m_bUseSBACRD = false;
-
+  m_bUseSBACRD = true;
   m_pcPic = pcPic;
   m_pcEntropyCoder = pcEntropyCoder;
 
   m_pcRDGoOnSbacCoder = pcRDGoOnSbacCoder;
+  m_pcEntropyCoder->setEntropyCoder(m_pcRDGoOnSbacCoder, pcPic->getSlice(0));
   m_pcEntropyCoder->resetEntropy();
   m_pcEntropyCoder->resetBits();
@@ -672,5 +731,5 @@
       if (classIdx)
       {
-        stats[classIdx] += (pOrg[x] - pRec[x]); 
+        stats[classIdx] += (pOrg[x] - pRec[x]);
         count[classIdx] ++;
       }
@@ -685,5 +744,4 @@
   pRec   = pRecStart;
 
-
   startX = (pbBorderAvail[SGU_L]) ? 0 : 1;
   endX   = (pbBorderAvail[SGU_R]) ? width : (width -1);
@@ -693,5 +751,5 @@
     for (x=startX; x< endX; x++)
     {
-      signRight =  xSign(pRec[x] - pRec[x+1]); 
+      signRight =  xSign(pRec[x] - pRec[x+1]);
       edgeType =  signRight + signLeft + 2;
       signLeft  = -signRight;
@@ -726,5 +784,5 @@
     for (x=0; x< width; x++)
     {
-      signDown     =  xSign(pRec[x] - pRec[x+stride]); 
+      signDown     =  xSign(pRec[x] - pRec[x+stride]);
       edgeType    =  signDown + m_iUpBuff1[x] + 2;
       m_iUpBuff1[x] = -signDown;
@@ -785,5 +843,5 @@
       count[m_auiEoTable[edgeType]] ++;
 
-      m_iUpBufft[x+1] = -signDown1; 
+      m_iUpBufft[x+1] = -signDown1;
     }
     m_iUpBufft[startX] = xSign(pRec[stride+startX] - pRec[startX-1]);
